with Reps, Messages,Reps.IO;
use Reps, Messages,Reps.IO;
with  Ada.Text_IO,Ada.Float_Text_IO;
use  Ada.Text_IO,Ada.Float_Text_IO;
--with S_Numerics, S_Numerics.IO;
--use S_Numerics, S_Numerics.IO;
with S_Intervals, S_Intervals.IO;
use S_Intervals, S_Intervals.IO;
with Scalars, Scalars.IO;
with Doubling;

procedure HD_Proof is

   subtype Scalar is Interval;
   --   subtype Scalar is Numeric;

   package Numbers is new Scalars (Scalar => Scalar);
   package Numbers_IO is new Numbers.IO;
   use Numbers,Numbers_IO;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   PDeg: constant Natural :=20;
   CutOff: constant Natural :=20;

   package Double is new Doubling (PDeg => PDeg,CutOff => CutOff,  Numbers => Numbers, Numbers_IO => Numbers_IO);
   use Double,Double.Tay,Double.Tay_IO;

   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;

   R,R1,R2: Radius ;
   Smal: constant Scalar:=Scal(0.0001);
   Ew11,Ew12,Ew21,Ew22,Er1,Ei1,Er2,Ei2,P,Lambda,LocDist, Mu,CenX,CenY,Cstar,Epsilon,Gamma,Dist,DF11,Wx1,Wu1,Vx1,Vu1,Wx11,Sx0,Su0,Sx1,Su1,Sx,Su: Scalar;
   Wx0,Wu0,Vx0,Vu0,Fact,LsN0,LsN1,LsP0,LsP1,LuN0,LuN1,LuP0,LuP1,MaxAng,MinAng,Lip,MinL0,MinL1,MaxL01,TL,TR,Dist0,Dist1,Bs,Cs,Es,MinExp,MaxExp,LHD,Rad,Ecc,Ew111,K0bx,K0bu,K0tx,K0tu,K1bx,K1bu,K1tx,K1tu,Sc,MaxC1,MinC1,MaxC0,MinC0: Scalar;
   S,Phi,Epss,Cor1,Cor2,Sigma: Taylor;
   Rc: Rep;
   N,Q,NN: Integer;
   DoLin,Hyp4: Boolean;
   FF: File_Type;

   NameP: String:="Output_Files/k-points";

   NameT0: String:="Output_Files/top0";
   NameB0: String:="Output_Files/bottom0";
   NameR0: String:="Output_Files/right0";
   NameL0: String:="Output_Files/left0";

   NameT1: String:="Output_Files/top1";
   NameB1: String:="Output_Files/bottom1";
   NameR1: String:="Output_Files/right1";
   NameL1: String:="Output_Files/left1";
   NameCen: String:="Data_Files/centers";
   NameCenn: String:="Output_Files/centers_1";

begin
   Read("Data_Files/psi_file",Phi);
   Read("Data_Files/epsilon_file",Epss);

   -------------------------------------------------------
   --THE PART OF THE PROGRAM BELOW IS INPUT DATA
   -------------------------------------------------------


   --VARIOUS INPUT DATA
   R:=Rho(Phi);
   R1:=Rep(0.95)*R;--radius for 1st order derivatives in computations of distortion
   R2:=Rep(0.9)*R;--radius for 2nd order derivatives in computations of distortion
   Rc:=Rep(0.999)*(R-Half);--intermidiate radius, irrelevant

   Lambda:=Scal(-0.24887681,-0.24887376);
   Mu:=Scal(0.061107811,0.061112465);

   Q:=5000;
   N:=3;
   NN:=1;
   DoLin:=True;

   Lip:=Scal(0.1);
   Sc:=Scal(0.55);
   Sx:=-Scal(Half)+Scal(-0.035);--center of the ellipse E_1, x-component
   Su:=-Scal(Half);--center of the ellipse E_1, u-component
   Rad:=Scal(0.17);--major axis of the ellipse E_1
   Ecc:=Scal(0.9975); --eccentricity of the ellipse E_1

   --THE GENERATING FUNCTION, HARDWIRED
   --------------------
   SetZero(R,Sigma);

   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 0, 0,Scal(-2.74160131730953815E-02  ));
   Sigma:=Sigma+Monom(R, 0, 1,Scal(  5.62681170825373906E-02));
   Sigma:=Sigma+Monom(R, 0, 2,Scal( -3.02218250463128873E-02));
   Sigma:=Sigma+Monom(R, 0, 3,Scal(  1.54830664195353367E-03));
   Sigma:=Sigma+Monom(R, 0, 4,Scal( -1.29578370556081318E-04));
   Sigma:=Sigma+Monom(R, 0, 5,Scal(  1.08523586647550293E-05));
   Sigma:=Sigma+Monom(R, 0, 6,Scal( -9.87372844807154123E-07));
   Sigma:=Sigma+Monom(R, 0, 7,Scal(  9.35463250541952263E-08));
   Sigma:=Sigma+Monom(R, 0, 8,Scal( -9.15390414245415699E-09));
   Sigma:=Sigma+Monom(R, 0, 9,Scal(  9.17640087941869132E-10));
   Sigma:=Sigma+Monom(R, 0, 10,Scal( -9.37621886025294370E-11));
   Sigma:=Sigma+Monom(R, 0, 11,Scal(  9.72897515408567785E-12));
   Sigma:=Sigma+Monom(R, 0, 12,Scal( -1.02231566401946393E-12));
   Sigma:=Sigma+Monom(R, 0, 13,Scal(  1.08518062717437766E-13));
   Sigma:=Sigma+Monom(R, 0, 14,Scal( -1.15942535488959455E-14));
   Sigma:=Sigma+Monom(R, 0, 15,Scal(  1.23599515512696595E-15));
   Sigma:=Sigma+Monom(R, 0, 16,Scal( -1.28585000700047043E-16));
   Sigma:=Sigma+Monom(R, 0, 17,Scal(  1.24514720295842190E-17));
   Sigma:=Sigma+Monom(R, 0, 18,Scal( -1.03253974956103418E-18));
   Sigma:=Sigma+Monom(R, 0, 19,Scal(  6.39459674649833898E-20));
   Sigma:=Sigma+Monom(R, 0, 20,Scal( -2.21947015573720828E-21));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 1, 0,Scal( 5.65481533619917242E-002));
   Sigma:=Sigma+Monom(R, 1, 1,Scal( -6.19492217723969832E-02));
   Sigma:=Sigma+Monom(R, 1, 2,Scal(  5.93807174326271387E-03));
   Sigma:=Sigma+Monom(R, 1, 3,Scal( -5.93487773041740667E-04));
   Sigma:=Sigma+Monom(R, 1, 4,Scal(  6.25816167804924208E-05));
   Sigma:=Sigma+Monom(R, 1, 5,Scal( -6.76751685892997385E-06));
   Sigma:=Sigma+Monom(R, 1, 6,Scal(  7.44983622962365231E-07));
   Sigma:=Sigma+Monom(R, 1, 7,Scal( -8.30344478679641766E-08));
   Sigma:=Sigma+Monom(R, 1, 8,Scal(  9.34133047199505171E-09));
   Sigma:=Sigma+Monom(R, 1, 9,Scal( -1.05848267856628115E-09));
   Sigma:=Sigma+Monom(R, 1, 10,Scal(  1.20627391873092709E-10));
   Sigma:=Sigma+Monom(R, 1, 11,Scal( -1.38103830339247743E-11));
   Sigma:=Sigma+Monom(R, 1, 12,Scal(  1.58649329924812359E-12));
   Sigma:=Sigma+Monom(R, 1, 13,Scal( -1.82397234498567151E-13));
   Sigma:=Sigma+Monom(R, 1, 14,Scal(  2.08225373563857082E-14));
   Sigma:=Sigma+Monom(R, 1, 15,Scal( -2.30982939070837354E-15));
   Sigma:=Sigma+Monom(R, 1, 16,Scal(  2.37289247076649578E-16));
   Sigma:=Sigma+Monom(R, 1, 17,Scal( -2.06723460004691074E-17));
   Sigma:=Sigma+Monom(R, 1, 18,Scal(  1.31304718438450657E-18));
   Sigma:=Sigma+Monom(R, 1, 19,Scal( -4.41137212506826846E-20));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 2, 0,Scal( -3.09746108861984916E-02));
   Sigma:=Sigma+Monom(R, 2, 1,Scal(  6.26224565328406937E-03));
   Sigma:=Sigma+Monom(R, 2, 2,Scal( -9.64053872656419222E-04));
   Sigma:=Sigma+Monom(R, 2, 3,Scal(  1.36477613732790871E-04));
   Sigma:=Sigma+Monom(R, 2, 4,Scal( -1.85333922562900126E-05));
   Sigma:=Sigma+Monom(R, 2, 5,Scal(  2.45490428163451961E-06));
   Sigma:=Sigma+Monom(R, 2, 6,Scal( -3.19826757733254156E-07));
   Sigma:=Sigma+Monom(R, 2, 7,Scal(  4.11768259077007967E-08));
   Sigma:=Sigma+Monom(R, 2, 8,Scal( -5.25452722171510151E-09));
   Sigma:=Sigma+Monom(R, 2, 9,Scal(  6.65900959441619633E-10));
   Sigma:=Sigma+Monom(R, 2, 10,Scal( -8.39172131076112916E-11));
   Sigma:=Sigma+Monom(R, 2, 11,Scal(  1.05224804698297739E-11));
   Sigma:=Sigma+Monom(R, 2, 12,Scal( -1.31128875998590285E-12));
   Sigma:=Sigma+Monom(R, 2, 13,Scal(  1.61323123956974548E-13));
   Sigma:=Sigma+Monom(R, 2, 14,Scal( -1.91943366587844501E-14));
   Sigma:=Sigma+Monom(R, 2, 15,Scal(  2.10687282191152510E-15));
   Sigma:=Sigma+Monom(R, 2, 16,Scal( -1.95480137810677296E-16));
   Sigma:=Sigma+Monom(R, 2, 17,Scal(  1.31833610500112333E-17));
   Sigma:=Sigma+Monom(R, 2, 18,Scal( -4.68854877258416078E-19));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 3, 0,Scal(  1.97935724775423796E-03));
   Sigma:=Sigma+Monom(R, 3, 1,Scal( -6.42702581770946148E-04));
   Sigma:=Sigma+Monom(R, 3, 2,Scal(  1.40548932455512415E-04));
   Sigma:=Sigma+Monom(R, 3, 3,Scal( -2.58808845800537627E-05));
   Sigma:=Sigma+Monom(R, 3, 4,Scal(  4.33187721265884872E-06));
   Sigma:=Sigma+Monom(R, 3, 5,Scal( -6.82346465140257720E-07));
   Sigma:=Sigma+Monom(R, 3, 6,Scal(  1.03059351081763895E-07));
   Sigma:=Sigma+Monom(R, 3, 7,Scal( -1.50936112909005718E-08));
   Sigma:=Sigma+Monom(R, 3, 8,Scal(  2.15907740504862205E-09));
   Sigma:=Sigma+Monom(R, 3, 9,Scal( -3.03136754693678475E-10));
   Sigma:=Sigma+Monom(R, 3, 10,Scal(  4.19055939637130821E-11));
   Sigma:=Sigma+Monom(R, 3, 11,Scal( -5.70801085466721054E-12));
   Sigma:=Sigma+Monom(R, 3, 12,Scal(  7.62159042743012559E-13));
   Sigma:=Sigma+Monom(R, 3, 13,Scal( -9.78544073866913812E-14));
   Sigma:=Sigma+Monom(R, 3, 14,Scal(  1.15362959050099303E-14));
   Sigma:=Sigma+Monom(R, 3, 15,Scal( -1.14507028158772648E-15));
   Sigma:=Sigma+Monom(R, 3, 16,Scal(  8.23184199568316731E-17));
   Sigma:=Sigma+Monom(R, 3, 17,Scal( -3.10992658374801134E-18));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 4, 0,Scal( -1.48371943260435167E-04));
   Sigma:=Sigma+Monom(R, 4, 1,Scal(  6.82388068663954357E-05));
   Sigma:=Sigma+Monom(R, 4, 2,Scal( -1.94106634350403221E-05));
   Sigma:=Sigma+Monom(R, 4, 3,Scal(  4.41568418143338155E-06));
   Sigma:=Sigma+Monom(R, 4, 4,Scal( -8.81149676177376050E-07));
   Sigma:=Sigma+Monom(R, 4, 5,Scal(  1.61283095284491786E-07));
   Sigma:=Sigma+Monom(R, 4, 6,Scal( -2.77659585647348581E-08));
   Sigma:=Sigma+Monom(R, 4, 7,Scal(  4.56626479940301427E-09));
   Sigma:=Sigma+Monom(R, 4, 8,Scal( -7.24724041408463285E-10));
   Sigma:=Sigma+Monom(R, 4, 9,Scal(  1.11761480431208660E-10));
   Sigma:=Sigma+Monom(R, 4, 10,Scal( -1.68023276723101105E-11));
   Sigma:=Sigma+Monom(R, 4, 11,Scal(  2.45493052889398600E-12));
   Sigma:=Sigma+Monom(R, 4, 12,Scal( -3.42476145284427248E-13));
   Sigma:=Sigma+Monom(R, 4, 13,Scal(  4.36202267830517402E-14));
   Sigma:=Sigma+Monom(R, 4, 14,Scal( -4.65527221341709267E-15));
   Sigma:=Sigma+Monom(R, 4, 15,Scal(  3.58309241445762178E-16));
   Sigma:=Sigma+Monom(R, 4, 16,Scal( -1.44357584681685310E-17));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 5, 0,Scal(  1.25163233560984842E-05));
   Sigma:=Sigma+Monom(R, 5, 1,Scal( -7.41335690251600503E-06));
   Sigma:=Sigma+Monom(R, 5, 2,Scal(  2.59912632759530923E-06));
   Sigma:=Sigma+Monom(R, 5, 3,Scal( -7.04919740941900840E-07));
   Sigma:=Sigma+Monom(R, 5, 4,Scal(  1.63586969339542905E-07));
   Sigma:=Sigma+Monom(R, 5, 5,Scal( -3.41650500122890421E-08));
   Sigma:=Sigma+Monom(R, 5, 6,Scal(  6.61171877885486316E-09));
   Sigma:=Sigma+Monom(R, 5, 7,Scal( -1.20765583575553320E-09));
   Sigma:=Sigma+Monom(R, 5, 8,Scal(  2.10724912738781508E-10));
   Sigma:=Sigma+Monom(R, 5, 9,Scal( -3.53724558067179952E-11));
   Sigma:=Sigma+Monom(R, 5, 10,Scal(  5.70927221997146627E-12));
   Sigma:=Sigma+Monom(R, 5, 11,Scal( -8.72339900709176626E-13));
   Sigma:=Sigma+Monom(R, 5, 12,Scal(  1.20845190240041589E-13));
   Sigma:=Sigma+Monom(R, 5, 13,Scal( -1.39463190710621499E-14));
   Sigma:=Sigma+Monom(R, 5, 14,Scal(  1.15495366212715274E-15));
   Sigma:=Sigma+Monom(R, 5, 15,Scal( -4.98377774186367369E-17));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 6, 0,Scal( -1.12791947648832897E-06));
   Sigma:=Sigma+Monom(R, 6, 1,Scal(  8.18301427211506538E-07));
   Sigma:=Sigma+Monom(R, 6, 2,Scal( -3.41173232570128860E-07));
   Sigma:=Sigma+Monom(R, 6, 3,Scal(  1.07522063522994524E-07));
   Sigma:=Sigma+Monom(R, 6, 4,Scal( -2.84708750102408685E-08));
   Sigma:=Sigma+Monom(R, 6, 5,Scal(  6.68653115380598254E-09));
   Sigma:=Sigma+Monom(R, 6, 6,Scal( -1.43793907168985478E-09));
   Sigma:=Sigma+Monom(R, 6, 7,Scal(  2.88923968259543084E-10));
   Sigma:=Sigma+Monom(R, 6, 8,Scal( -5.49097655866865035E-11));
   Sigma:=Sigma+Monom(R, 6, 9,Scal(  9.90183173250085094E-12));
   Sigma:=Sigma+Monom(R, 6, 10,Scal( -1.67253816288539462E-11));
   Sigma:=Sigma+Monom(R, 6, 11,Scal(  2.53965110834350945E-13));
   Sigma:=Sigma+Monom(R, 6, 12,Scal( -3.19019930767643026E-14));
   Sigma:=Sigma+Monom(R, 6, 13,Scal(  2.85855811828469684E-15));
   Sigma:=Sigma+Monom(R, 6, 14,Scal( -1.32761828229061334E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 7, 0,Scal(  1.06426231851766462E-07));
   Sigma:=Sigma+Monom(R, 7, 1,Scal( -9.13790736380726160E-08));
   Sigma:=Sigma+Monom(R, 7, 2,Scal(  4.41682933207559550E-08));
   Sigma:=Sigma+Monom(R, 7, 3,Scal( -1.58662620369913475E-08));
   Sigma:=Sigma+Monom(R, 7, 4,Scal(  4.72265627061061654E-09));
   Sigma:=Sigma+Monom(R, 7, 5,Scal( -1.23251920430558982E-09));
   Sigma:=Sigma+Monom(R, 7, 6,Scal(  2.91630529962384718E-10));
   Sigma:=Sigma+Monom(R, 7, 7,Scal( -6.38414940451486469E-11));
   Sigma:=Sigma+Monom(R, 7, 8,Scal(  1.30393284407924363E-11));
   Sigma:=Sigma+Monom(R, 7, 9,Scal( -2.46192937333265655E-12));
   Sigma:=Sigma+Monom(R, 7, 10,Scal(  4.13500312022872994E-13));
   Sigma:=Sigma+Monom(R, 7, 11,Scal( -5.69670080468160246E-14));
   Sigma:=Sigma+Monom(R, 7, 12,Scal(  5.55859287385010025E-15));
   Sigma:=Sigma+Monom(R, 7, 13,Scal( -2.79401927685878662E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 8, 0,Scal( -1.03793059834955221E-08));
   Sigma:=Sigma+Monom(R, 8, 1,Scal(  1.02942064769251992E-08));
   Sigma:=Sigma+Monom(R, 8, 2,Scal( -5.66010423408771442E-09));
   Sigma:=Sigma+Monom(R, 8, 3,Scal(  2.28313239970150714E-09));
   Sigma:=Sigma+Monom(R, 8, 4,Scal( -7.54784897347208250E-10));
   Sigma:=Sigma+Monom(R, 8, 5,Scal(  2.16692976194657313E-10));
   Sigma:=Sigma+Monom(R, 8, 6,Scal( -5.58613072895050661E-11));
   Sigma:=Sigma+Monom(R, 8, 7,Scal(  1.31439002736733006E-11));
   Sigma:=Sigma+Monom(R, 8, 8,Scal( -2.81148967295183105E-12));
   Sigma:=Sigma+Monom(R, 8, 9,Scal(  5.28014778448605874E-13));
   Sigma:=Sigma+Monom(R, 8, 10,Scal( -8.04940930602974822E-14));
   Sigma:=Sigma+Monom(R, 8, 11,Scal(  8.61693982170072846E-15));
   Sigma:=Sigma+Monom(R, 8, 12,Scal( -4.71755128470299530E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 9, 0,Scal(  1.03792560799945019E-09));
   Sigma:=Sigma+Monom(R, 9, 1,Scal( -1.16767271593668923E-09));
   Sigma:=Sigma+Monom(R, 9, 2,Scal(  7.19692468349540682E-10));
   Sigma:=Sigma+Monom(R, 9, 3,Scal( -3.22099573959317015E-10));
   Sigma:=Sigma+Monom(R, 9, 4,Scal(  1.17069395965989727E-10));
   Sigma:=Sigma+Monom(R, 9, 5,Scal( -3.66065103911243357E-11));
   Sigma:=Sigma+Monom(R, 9, 6,Scal(  1.01416998983941172E-11));
   Sigma:=Sigma+Monom(R, 9, 7,Scal( -2.49910193151273871E-12));
   Sigma:=Sigma+Monom(R, 9, 8,Scal(  5.31784274011477496E-13));
   Sigma:=Sigma+Monom(R, 9, 9,Scal( -9.06666126112754437E-14));
   Sigma:=Sigma+Monom(R, 9, 10,Scal(  1.07422145845197794E-14));
   Sigma:=Sigma+Monom(R, 9, 11,Scal( -6.45302645964689891E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 10, 0,Scal( -1.05848267856628115E-10));
   Sigma:=Sigma+Monom(R, 10, 1,Scal(  1.33180191888323927E-10));
   Sigma:=Sigma+Monom(R, 10, 2,Scal( -9.09410264081035426E-11));
   Sigma:=Sigma+Monom(R, 10, 3,Scal(  4.47045921724834640E-11));
   Sigma:=Sigma+Monom(R, 10, 4,Scal( -1.76862279033589976E-11));
   Sigma:=Sigma+Monom(R, 10, 5,Scal(  5.94109903950051056E-12));
   Sigma:=Sigma+Monom(R, 10, 6,Scal( -1.72335056133285959E-12));
   Sigma:=Sigma+Monom(R, 10, 7,Scal(  4.22411822758884699E-13));
   Sigma:=Sigma+Monom(R, 10, 8,Scal( -8.15999513501478993E-14));
   Sigma:=Sigma+Monom(R, 10, 9,Scal(  1.08133294048250410E-14));
   Sigma:=Sigma+Monom(R, 10, 10,Scal( -7.18978414330193652E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 11, 0,Scal(  1.09661265339175190E-11));
   Sigma:=Sigma+Monom(R, 11, 1,Scal( -1.52576751104747803E-11));
   Sigma:=Sigma+Monom(R, 11, 2,Scal(  1.14287983537399315E-11));
   Sigma:=Sigma+Monom(R, 11, 3,Scal( -6.10993733538549472E-12));
   Sigma:=Sigma+Monom(R, 11, 4,Scal(  2.59512373635066648E-12));
   Sigma:=Sigma+Monom(R, 11, 5,Scal( -9.12293543392033430E-12));
   Sigma:=Sigma+Monom(R, 11, 6,Scal(  2.63136562196373723E-13));
   Sigma:=Sigma+Monom(R, 11, 7,Scal( -5.85411585893072598E-14));
   Sigma:=Sigma+Monom(R, 11, 8,Scal(  8.78908466006163765E-15));
   Sigma:=Sigma+Monom(R, 11, 9,Scal( -6.53616740300176048E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 12, 0,Scal( -1.15086525282706452E-12));
   Sigma:=Sigma+Monom(R, 12, 1,Scal(  1.75374674497162899E-12));
   Sigma:=Sigma+Monom(R, 12, 2,Scal( -1.42700271366680263E-12));
   Sigma:=Sigma+Monom(R, 12, 3,Scal(  8.18310176297995332E-13));
   Sigma:=Sigma+Monom(R, 12, 4,Scal( -3.63474958628823594E-13));
   Sigma:=Sigma+Monom(R, 12, 5,Scal(  1.26982555417175472E-13));
   Sigma:=Sigma+Monom(R, 12, 6,Scal( -3.32307546939760144E-14));
   Sigma:=Sigma+Monom(R, 12, 7,Scal(  5.74462654780048564E-15));
   Sigma:=Sigma+Monom(R, 12, 8,Scal( -4.83976984473517419E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 13, 0,Scal(  1.22037946096009507E-13));
   Sigma:=Sigma+Monom(R, 13, 1,Scal( -2.01736732305523515E-13));
   Sigma:=Sigma+Monom(R, 13, 2,Scal(  1.75882856017618283E-13));
   Sigma:=Sigma+Monom(R, 13, 3,Scal( -1.05377275472131461E-13));
   Sigma:=Sigma+Monom(R, 13, 4,Scal(  4.64789193230929189E-14));
   Sigma:=Sigma+Monom(R, 13, 5,Scal( -1.47239968046604474E-14));
   Sigma:=Sigma+Monom(R, 13, 6,Scal(  2.99308847053466937E-15));
   Sigma:=Sigma+Monom(R, 13, 7,Scal( -2.90310848289415096E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 14, 0,Scal( -1.30283738927547965E-14));
   Sigma:=Sigma+Monom(R, 14, 1,Scal(  2.30461605652820783E-14));
   Sigma:=Sigma+Monom(R, 14, 2,Scal( -2.09688015828624388E-14));
   Sigma:=Sigma+Monom(R, 14, 3,Scal(  1.24629219380147829E-14));
   Sigma:=Sigma+Monom(R, 14, 4,Scal( -4.98082823966505355E-15));
   Sigma:=Sigma+Monom(R, 14, 5,Scal(  1.22509633640772722E-15));
   Sigma:=Sigma+Monom(R, 14, 6,Scal( -1.39700963842939331E-16));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 15, 0,Scal(  1.38816915709238054E-15));
   Sigma:=Sigma+Monom(R, 15, 1,Scal( -2.55924488783792668E-15));
   Sigma:=Sigma+Monom(R, 15, 2,Scal(  2.30725918100198605E-15));
   Sigma:=Sigma+Monom(R, 15, 3,Scal( -1.24140592357789138E-15));
   Sigma:=Sigma+Monom(R, 15, 4,Scal(  3.84984554042384247E-16));
   Sigma:=Sigma+Monom(R, 15, 5,Scal( -5.31047312916245334E-17));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 16, 0,Scal( -1.44364336919273346E-16));
   Sigma:=Sigma+Monom(R, 16, 1,Scal(  2.63359102738940638E-16));
   Sigma:=Sigma+Monom(R, 16, 2,Scal( -2.14700677797698714E-16));
   Sigma:=Sigma+Monom(R, 16, 3,Scal(  8.95773103614405444E-17));
   Sigma:=Sigma+Monom(R, 16, 4,Scal( -1.55743054433239803E-17));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 17, 0,Scal(  1.39581910045087987E-17));
   Sigma:=Sigma+Monom(R, 17, 1,Scal( -2.29976632718443878E-17));
   Sigma:=Sigma+Monom(R, 17, 2,Scal(  1.45267799923820600E-17));
   Sigma:=Sigma+Monom(R, 17, 3,Scal( -3.39664905133377200E-18));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 18, 0,Scal( -1.14846366669272819E-18));
   Sigma:=Sigma+Monom(R, 18, 1,Scal(  1.46481789444569259E-18));
   Sigma:=Sigma+Monom(R, 18, 2,Scal( -5.18321097291335223E-19));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 19, 0,Scal(  6.91077465465529775E-20));
   Sigma:=Sigma+Monom(R, 19, 1,Scal( -4.93531449745701134E-20));
   -------------------------------------------------
   Sigma:=Sigma+Monom(R, 20, 0,Scal( -2.20568606253413423E-21));


   --NORMALIZATION OF S
   Fact:=(Scal(5.0)/Scal(5.13674200963507523E+000));
   Es:=Fact*Scal(0.2);
   Bs:=Fact*Scal(1.9118611,1.9118725);
   Cs:=Fact*Scal(0.82728796,0.82729138);
   --General error:= 6.0E-007
   S:=
     Monom(R,1,0,Cs+Es) - Monom(R,0,0,Cs+Es) +Monom(R,0,1,Es)+Monom(R,0,2,Half*Bs)+Fact*Sigma;
   S:=Comp(Monom(Rc,1,0,Scal(One))+Monom(Rc,0,0,Scal(Half)),Monom(Rc,0,1,Scal(One))+Monom(Rc,0,0,Scal(Half)),S);
   Sigma:=Comp(Monom(Rc,1,0,Scal(One))+Monom(Rc,0,0,Scal(Half)),Monom(Rc,0,1,Scal(One))+Monom(Rc,0,0,Scal(Half)),Fact*Sigma);
   SetRho(R,Sigma);
   Sigma:=Sigma+Monom(R,2,0,Ball(Scal(6.0E-07))/Sqr(Scal(R)));
   SetRho(R,S);
   S:=S+Monom(R,2,0,Ball(Scal(6.0E-07))/Sqr(Scal(R)));


   --SPANS OF THE HORSESHOE COMPONENTS
   --Unstable vector (Wx0,Wu0), component 0
   Wx0:=Scal(0.788578889012330);
   Wu0:= Scal(0.614933602760558);
   Wx11:=Wx0;
   Wx0:=Wx0/Sqrt(Sqr(Wx0)+Sqr(Wu0)  );
   Wu0:=Wu0/Sqrt(Sqr(Wx11)+Sqr(Wu0)  );
   --Stable vector (Vx0,Vu0), component 0
   Vx0:=Wx0;
   Vu0:=-Wu0;

   --Unstable and stable vectors (Wx1,Wu1) and (Vx1,Vu1), component 1
   Wx1:= Scal(0.682259082166558);
   Wu1:= Scal(-0.731107710380897);
   Wx11:=Wx1;
   Wx1:=Wx1/Sqrt(Sqr(Wx1)+Sqr(Wu1)  );

   Vx1:=Wx1;
   Vu1:= Scal(0.6);
   Wx11:=Vx1;
   Vx1:=Vx1/Sqrt(Sqr(Vx1)+Sqr(Vu1)  );
   Vu1:=Vu1/Sqrt(Sqr(Wx11)+Sqr(Vu1)  );

   Wx1:=Vx1;
   Wu1:=-Vu1;

   --OUTPUT THE SPANS
   Put("Stable vector, Delta_0:");
   Show(Vx0);
   Show(Vu0);
   Put("Unstable vector, Delta_0:");
   Show(Wx0);
   Show(Wu0);

   Put("Stable vector, Delta_1:");
   Show(Vx1);
   Show(Vu1);
   Put("Unstable vector, Delta_1:");
   Show(Wx1);
   Show(Wu1);


   --UNSTABLE CONE FIELDS
   --Component 1
   MaxC1:=Scal(0.05);
   MinC1:=Scal(-0.1);
   --Component 0
   MaxC0:=Scal(0.2);
   MinC0:=Scal(-0.15);


   --SIZES OF COMPONENTS
   --Centers for components 0 and 1
   Sx0:=Scal(0.170198);
   Su0:=Scal(-0.00)-Scal(Half);
   Sx1:=Scal(-0.941811);
   Su1:=Scal(0.000)-Scal(Half);

   --Sizes of component 0
   LuP0:=Scal(0.083);
   LuN0:=Scal(0.083);
   LsP0:=Scal(0.083);
   LsN0:=Scal(0.083);

   --Sizes of component 1
   LuP1:=Scal(0.0655);
   LuN1:=Scal(0.0655);
   LsP1:=Scal(0.0655);
   LsN1:=Scal(0.0655);


   --BOUNDS ON THE END POINTS OF THE MARKOV PARTITION OF K^u_*
   K0bx:=Sc*Scal((0.0754113),(0.0819844));
   K0bu:=Sc*Scal((0.0211402),(0.0277133));

   K0tx:=Sc*Scal((0.0628697),(0.0672518));
   K0tu:=Sc*Scal((0.0422687),(0.0466508));

   K1bx:=Sc*Scal((0.18148),(0.185862));
   K1bu:=Sc*Scal((-0.143003),(-0.138621));

   K1tx:=Sc*Scal((0.172493),(0.175647));
   K1tu:=Sc*Scal((-0.126923),(-0.122005));


   --PERIODIC POINTS AND RELATED DATA
   New_Line;
   Put("FIXED POINT AND RELATED DATA:");
   New_Line;

   P:=Scal(0.07);
   Newton(Bs,Cs,Es,P,Sigma,Scal(Zero));
   New_Line;
   Put("Fixed point (P,0):");
   New_Line;
   Put("P=(");
   Txt_Put(Current_Output,Inf(P)+Half);
   Put(",");
   Txt_Put(Current_Output,Sup(P)+Half);
   Put(")");
   New_Line;
   --   Put("Verification: S(P,P)=");Show(Val(Bs,Cs,Es,P,P,S));
   EigenData(Bs,Cs,Es,P,Sigma,Er1,Er2,Ei1,Ei2,Ew11,Ew12,Ew21,Ew22);
   Put("Eigenvalues:");
   New_Line;
   Txt_Put(Current_Output,Inf(Er1));
   Put(",");
   Txt_Put(Current_Output,Sup(Er1));
   Put(")");
   Put("+I*");Show(Ei1);
   New_Line;
   Txt_Put(Current_Output,Inf(Er2));
   Put(",");
   Txt_Put(Current_Output,Sup(Er2));
   Put(")");
   Put("+I*");Show(Ei2);
   Ew111:=Ew11;
   Ew11:=Ew11/Sqrt(Sqr(Ew11)+Sqr(Ew12));
   Ew12:=Ew12/Sqrt(Sqr(Ew111)+Sqr(Ew12));

   Ew111:=Ew21;
   Ew21:=Ew21/Sqrt(Sqr(Ew21)+Sqr(Ew22));
   Ew22:=Ew22/Sqrt(Sqr(Ew111)+Sqr(Ew22));

   Put("Eigenvectors:");
   New_Line;
   Put("[");Show(Ew11,False);Put(",");Show(Ew12,False);Put("]");New_Line;
   Put("[");Show(Ew21,False);Put(",");Show(Ew22,False);Put("]");New_Line;


   CenX:=P;
   CenY:=Scal(-Half);


   --LINEARIZING COORDINATE
   Manifold(Rep(100.0)*R,Scal(0.2),Scal(-0.437),Scal(-0.9),Scal(-0.49),Scal(-0.6),Scal(-0.66),Scal(-0.2),Scal(-0.66),CenX,CenY,Sc,Cor1,Cor2);

   SetRho(R,Cor1);
   SetRho(R,Cor2);
   --   Cor1:=Cor1-Monom(R,0,0,Val(Bs,Cs,Es,P-CenX,Scal(-Half)-CenY,Cor1));
   --   Cor2:=Cor2-Monom(R,0,0,Val(Bs,Cs,Es,P-CenX,Scal(-Half)-CenY,Cor2));

   New_Line;
   Put("APPROXIMATE LINEARIZING COORDINATE:");
   New_Line;
   Put("First component:");
   New_Line;
   Show(Cor1);
   New_Line;
   Put("Second component:");
   New_Line;
   Show(Cor2);







   -------------------------------------------------------
   --THE PART OF THE PROGRAM BELOW IS COMPUTATIONS
   -------------------------------------------------------
   New_Line;
   Put("BOUNDS ON THICKNESSES OF THE MARKOV PARTITION OF K^u_*:");
   New_Line;

   Gaps(DoLin,NameP,NameCen,NameCenn,10000,N,K0bx,K0bu,K0tx,K0tu,K1bx,K1bu,K1tx,K1tu,Sc,Lip,Bs,Cs,Es,Lambda,Mu,P,Scal(-Half),Sx0,Su0,Sx1,Su1,CenX,CenY,Wx0,Wu0,Vx0,Vu0,Vx1,Vu1,Wx1,Wu1,Ew21,Ew22,Phi,S,Sigma,Cor1,Cor2,MinL0,MinL1,MaxL01);
   TL:=MinL0/MaxL01;
   TR:=MinL1/MaxL01;

   New_Line;
   Put("Minimum length of the stable mnfd in G(S_0)=");Show(MinL0);
   Put("Minimum length of the stable mnfd in G(S_1)=");Show(MinL1);
   Put("Maximum length of the stable mnfd in the gap=");Show(MaxL01);

   TL:=MinL0/MaxL01;
   TR:=MinL1/MaxL01;

   Put("Lower bound on the left thickness of the partition=");Show(Scal(Inf(TL)));
   Put("Lower bound on the right thickness of the partition=");Show(Scal(Inf(TR)));


   --DRAWING THE HARSESHOE< VERY OPTIONAL
   DoLin:=False;
   DrawHS(DoLin,NameT0,NameB0,NameR0,NameL0,2000,N,LsP0,LsN0,LuP0,LuN0,Lambda,Mu,Bs,Cs,Es,Sx0,Su0,CenX,CenY,Wx0,Wu0,Vx0,Vu0,Phi,Sigma,Cor1,Cor2);
   DrawHS(DoLin,NameT1,NameB1,NameR1,NameL1,2000,N,LsP1,LsN1,LuP1,LuN1,Lambda,Mu,Bs,Cs,Es,Sx1,Su1,CenX,CenY,Wx1,Wu1,Vx1,Vu1,Phi,Sigma,Cor1,Cor2);


   New_Line;
   New_Line;
   Put("DISTORTION DATA FOR COMPONENT 1:");
   New_Line;
   Distortion(1,Q,3,R1,R2,MaxC1,MinC1,LsP1,LsN1,LuP1,LuN1,LsP0,LsN0,LuP0,LuN0,Bs,Cs,Es,Lambda,Mu,Sx1,Su1,Sx0,Su0,CenX,CenY,Wx1,Wu1,Vx1,Vu1,Wx0,Wu0,Vx0,Vu0,Phi,S,Sigma,Cor1,Cor2,Cstar,Epsilon,Gamma,DF11,LocDist,MinExp,MaxExp,MinAng,MaxAng,Hyp4);

   New_Line;
   New_Line;
   if Hyp4 then
      Put("Hypothesis 4 verified");
   else
      Put("Hypothesis 4 is not verified");
   end if;
   New_Line;
   Put("Minimal angle between the unstable cone and the x-axis=");Show(Scal(Inf(MinAng)));
   Put("Maximal angle between the unstable cone and the x-axis=");Show(Scal(Sup(MaxAng)));
   Put("Minimal expansion=");Show(Scal(Inf(MinExp)));
   Put("Maximal expansion=");Show(Scal(Sup(MaxExp)));
   Put("|DF(1,1)|=");Show(DF11);
   Put("C*=");Show(Scal(Sup(Cstar)));
   Put("Epsilon=");Show(Scal(Sup(Epsilon)));
   Put("Gamma=");Show(Scal(Sup(Gamma)));
   Put("Needed distance between S0 and S1=");Show(Epsilon/Gamma);
   Dist1:=(Scal(4.0)*(Cstar+Scal((3.0)))*Gamma+Two*Epsilon);
   Put("Local distortion D=");Show(LocDist);
   Put("Distortion D=");Show(Dist1);
   Put("exp[-D]=");Show(Exp(-Dist1));



   New_Line;
   Put("DISTORTION DATA FOR COMPONENT 0:");
   New_Line;
   Distortion(0,Q,3,R1,R2,MaxC0,MinC0,LsP0,LsN0,LuP0,LuN0,LsP1,LsN1,LuP1,LuN1,Bs,Cs,Es,Lambda,Mu,Sx0,Su0,Sx1,Su1,CenX,CenY,Wx0,Wu0,Vx0,Vu0,Wx1,Wu1,Vx1,Vu1,Phi,S,Sigma,Cor1,Cor2,Cstar,Epsilon,Gamma,DF11,LocDist,MinExp,MaxExp,MinAng,MaxAng,Hyp4);

   New_Line;
   New_Line;
   if Hyp4 then
      Put("Hypothesis 4 verified");
   else
      Put("Hypothesis 4 is not verified");
   end if;
   New_Line;
   Put("Minimal angle between the unstable cone and the x-axis=");Show(Scal(Inf(MinAng)));
   Put("Maximal angle between the unstable cone and the x-axis=");Show(Scal(Sup(MaxAng)));
   Put("Minimal expansion=");Show(Scal(Inf(MinExp)));
   Put("Maximal expansion=");Show(Scal(Sup(MaxExp)));
   Put("|DF(1,1)|=");Show(DF11);
   Put("C*=");Show(Scal(Sup(Cstar)));
   Put("Epsilon=");Show(Scal(Sup(Epsilon)));
   Put("Gamma=");Show(Scal(Sup(Gamma)));
   Put("Needed distance between S0 and S1=");Show(Epsilon/Gamma);
   Dist0:=(Scal(4.0)*(Cstar+Scal(3.0))*Gamma+Two*Epsilon);
   Put("Local distortion D=");Show(LocDist);
   Put("Distortion D=");Show(Dist0);
   Put("exp[-D]=");Show(Exp(-Dist0));




   Dist:=Max(Dist1,Dist0);
   TL:=Scal(Inf(TL*Exp(-Dist)));
   TR:=Scal(Inf(TR*Exp(-Dist)));
   Put("DISTORTION=");Show(Scal(Sup(Dist)));
   LHD:=Max(Log(Scal(One)+TR/(Scal(One)+TL))/Log(Scal(One)+(Scal(One)+TR)/TL),Log(Scal(One)+TL/(Scal(One)+TR))/Log(Scal(One)+(Scal(One)+TL)/TR)   );

   return;
end HD_Proof;





